package com.acme.wsTest;

import java.rmi.RemoteException;

import org.apache.axis2.client.ServiceClient;
import org.apache.axis2.context.ConfigurationContext;
import org.apache.axis2.context.ConfigurationContextFactory;
import org.apache.rampart.handler.WSSHandlerConstants;
import org.apache.rampart.handler.config.OutflowConfiguration;

import com.acme.customization.CustomWebServiceStub;
import com.acme.customization.GetFirstNItems;
import com.acme.customization.GetFirstNItemsResponse;


public class TestClass {

private static String m_RootURL = "http://localhost:8080/UnityWebTier/services/";
    
    public static void main(java.lang.String args[])
    {
      try
		{
			ConfigurationContext cfg = ConfigurationContextFactory.createConfigurationContextFromFileSystem("D:\\Osman",null);
			CustomWebServiceStub stub = new CustomWebServiceStub(cfg, m_RootURL+"CustomWebService" );
			ServiceClient sc = stub._getServiceClient();
			sc.engageModule("addressing");
			sc.engageModule("rampart");			

			OutflowConfiguration outflowConfig = new OutflowConfiguration();
			outflowConfig.setActionItems("UsernameToken");
			outflowConfig.setUser("admin");
			outflowConfig.setPasswordCallbackClass("com.acme.wsTest.SampleCallBackHandler");
			sc.getOptions().setProperty(WSSHandlerConstants.OUTFLOW_SECURITY, outflowConfig.getProperty());
			
			getItems(stub);
			
		}
		catch (RemoteException e)
		{
			e.printStackTrace();
		}
    }

	private static void getItems(CustomWebServiceStub stub) 
	{
		try 
		{
			GetFirstNItems methodParams = new GetFirstNItems();
			methodParams.setFirm(1);
			methodParams.setPeriod(1);
			methodParams.setLanguage("TRTR");
			methodParams.setRowCount(3);
			GetFirstNItemsResponse methodRes = stub.getFirstNItems(methodParams);
			String[] returnVal = methodRes.get_return();
			for(int i =0 ; i < returnVal.length;i++)
			{
				System.out.println(returnVal[i]);
			}
		} 
		catch (RemoteException e) 
		{
			e.printStackTrace();
		}
		
	}


}
